#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hal.h"

char *wordlist[65536];
char *werdlist[65536];
char punctlist[65536];
int ntotal=0;
int nwords=0;

void makewordlist(char *s)
{ int i;
  char *s2, b, f=0;

  while(*s)
  { while(*s && !isalnum(*s)) s++;
    if(!*s) break;
    s2=s;
    while(*s2 && (isalnum(*s2) || *s2=='\'')) s2++;
    if(!*s2) break;
    b=*s2;
    *s2=0;
    f=0;
    for(i=0; i<nwords; i++)
      if(!strcmp(wordlist[i], s))
      { f=1;
        werdlist[ntotal]=wordlist[i];
      }
    if(!f)
    { wordlist[nwords]=malloc(strlen(s)+1);
      strcpy(wordlist[nwords], s);
      werdlist[ntotal]=wordlist[nwords];
      nwords++;
    }
    if(b=='.' || b==',' || b=='!' || b=='?') punctlist[ntotal++]=b;
    else punctlist[ntotal++]=0;
    *s2=b;
    s=s2;
  }
}

int nextword()
{ static int thisword=0, prevword=0;
  int i, n, t;

  if(thisword==prevword || thisword==ntotal-1)
  { prevword=rand()%(ntotal-2);
    thisword=prevword+1;
  }

  for(i=n=0; i<ntotal; i++)
    if(werdlist[i]==werdlist[prevword] &&
       werdlist[i+1]==werdlist[thisword]) n++;

  t=rand()%n;
  for(i=n=0; n<=t; i++)
    if(werdlist[i]==werdlist[prevword] &&
       werdlist[i+1]==werdlist[thisword]) n++;
  prevword=i;
  thisword=i+1;

  return thisword;
}

char nextchar()
{ static int cword=-1, cchar=0, sp=0;
  char p;

  if(sp) 
  { sp=0;
    return ' ';
  }
  if(cword==-1)
    cword=nextword();

  if(werdlist[cword][cchar]) return werdlist[cword][cchar++];

  p=punctlist[cword];
  cchar=0;
  cword=nextword();
  if(!p) return ' ';
  else
  { sp=1;
    return p;
  }
}