#include <conio.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "graph.h"
#include "hal.h"
#include "music.h"
#include "pud.h"

char shadow=1, dlogo=1, spotlite=1, antialias=1, waitr=1, crackr=0;
char joyscrowl=0, spotint=128;

char *font, *joy, *pal, *pal2, *bg, *logo, *yoj, *crack;
char *scroll;
char spotlight[448*328];
char spawtlight[448*328];
char *cmap;

char scrollspace[320*36];
char bgp[64000], logop[64000], joyp[64000], yojp[64000], crackp[64000];
char cracki[64000];
char joydat[37*45];
char yojdat[43*47];
char palint[256];
char palint2[256];

char alfa[]="abcdefghijklmnopqrstuvwxyz0123456789.,!:()?-;\"'@ab#$%^&*/{}=";
int scrp=0, scri=0;
int joyc=0, yojc=0;
int spotx=0, spoty=0, spotxv=0, spotyv=0;

void advjoy()
{ updateinfo();
  if(row%8==0) joyc=63;
  if(row%8==4) yojc=63;
  if(joyc>0) joyc--;
  if(yojc>0) yojc--;
}

void drawjoy()
{ int i, j;
  char *s, *d;

  d=screen2;
  s=joydat;
  for(i=0; i<45; i++, d+=320-37)
    for(j=0; j<37; j++, d++)
      *d=cmap[(*s++*joyc/63+128)*256+*d];

  d=screen2+275;
  s=yojdat;
  for(i=0; i<47; i++, d+=320-43)
    for(j=0; j<43; j++, d++)
      *d=cmap[(*s++*yojc/63+128)*256+*d];
}

void initscroller()
{ int i;
  for(i=0; i<320*36; i++) scrollspace[i]=0x45;
}

void advscroller()
{ char *s, *d;
  int i;

  if(!scroll[scrp]) scroll[--scrp]=nextchar();
  for(i=0; alfa[i] && alfa[i]!=scroll[scrp]; i++);
  if(alfa[i]) s=font+scri*36+i*20*36;
  else s=font;
  d=scrollspace+319;
  memcpy(scrollspace, scrollspace+1, 320*36);
  for(i=0; i<36; i++, d+=320, s++) *d=*s;
  if(++scri>19) scrp++, scri=0;
}

void drawscroller()
{ int i;
  char *d;

  d=screen2+320*163;
  if(antialias)
  { for(i=0; i<320*36; i++, d++)
      if(scrollspace[i]==2)
        *d=scrollspace[i];
      else if(scrollspace[i]!=0x45)
        *d=cmap[screen2[i+320*163]+palint[scrollspace[i]]*256];
  }
  else
  { for(i=0; i<320*36; i++, d++)
      if(scrollspace[i]!=0x45)
        *d=scrollspace[i];
  }
}

char logosp[65000];
char logospace[65000];

void putlogo(char *dest, int x, int y)
{ int i, j;
  char *s, *d;

  s=logop;
  d=dest+y*320+x;
  for(i=0; i<140; i++, d+=320-180, s+=320-180)
    for(j=0; j<180; j++, d++, s++)
      if(*s) *d=*s;
}

void putlogo2(char *dest, int x, int y)
{ int i, j;
  char *s, *d;

  s=logop;
  d=dest+y*320+x;
  for(i=0; i<140; i++, d+=320-180, s+=320-180)
    for(j=0; j<180; j++, d++, s++)
      if(*s) *d=64;
}

void putlogo3(char *dest, int x, int y)
{ int i, j;
  char *s, *d;

  s=logosp;
  d=dest+y*320+x;
  for(i=0; i<140; i++, d+=320-180, s+=320-180)
    for(j=0; j<180; j++, d++, s++)
      if(*s) *d=*s;
}


int dec4[256];

void feedback(char *dest, char *src, int x, int y)
{ int i, j, pr, q, r, n=320;

  for(i=1; i<199; i++)
  { pr=((i-y)*7/8+y)*320;
    for(j=1; j<319; j++)
    { q=pr+(j-x)*7/8+x;
      r=(src[n+1]+src[n-1]+src[n+320]+src[n-320])>>2;
      r=dec4[r];
      dest[q]=r;
      n++;
    }
    n+=2;
  }
}

void initfeedback()
{ int i;
  for(i=0; i<256; i++)
    if(i-4<0) dec4[i]=0;
    else dec4[i]=i-4;

  memset(logosp, 0, 64000);
  memset(logospace, 0, 64000);
  putlogo2(logospace, 0, 0);
  feedback(logosp, logospace, 90, 70);
}

int logox=0, logoy=0, logoxv=0, logoyv=0;

void advlogo()
{ logox+=logoxv;
  logoy+=logoyv;
  if(logox<50*16) logoxv++; else logoxv--;
  if(logoy<30*16) logoyv++; else logoyv--;
}

void drawlogo()
{ int i;

  if(shadow)
  { memset(logospace, 0, 64000);
    putlogo3(logospace, ((logox/16+20)*3+140-spotx/16)/4,
                        ((logoy/16)*3+100-spoty/16)/4);
    for(i=0; i<64000; i++)
      screen2[i]=cmap[(128-logospace[i])*256+screen2[i]];
  }
  if(dlogo) putlogo(screen2, logox/16+20, logoy/16);
}

unsigned char colormap(unsigned char color, unsigned char intensity)
{
  int r,g,b;
  int i;
  unsigned char c=0;
  unsigned long d=255,cd;

  r=(int)pal[color*3]*intensity/128;
  g=(int)pal[color*3+1]*intensity/128;
  b=(int)pal[color*3+2]*intensity/128;
 
  for(i=0; i<256; i++)
  {
    cd=abs(r-pal[i*3]);
    cd+=abs(g-pal[i*3+1]);
    cd+=abs(b-pal[i*3+2]);
    if(cd<d) c=i,d=cd;
  }

  return c;
}

unsigned char colormap2(unsigned char color, unsigned char intensity)
{
  int r,g,b;
  int i;
  unsigned char c=0;
  unsigned long d=255,cd;

  r=(int)pal[color*3]*intensity/128+63-intensity/2;
  g=(int)pal[color*3+1]*intensity/128+63-intensity/2;
  b=(int)pal[color*3+2]*intensity/128+63-intensity/2;
 
  for(i=0; i<256; i++)
  {
    cd=abs(r-pal[i*3]);
    cd+=abs(g-pal[i*3+1]);
    cd+=abs(b-pal[i*3+2]);
    if(cd<d) c=i,d=cd;
  }

  return c;
}

void initcmap()
{ int i,j;
  FILE *f;

  for(i=0; i<256; i++)
  { printf("%d ",i);
    for(j=0; j<128; j++)
      cmap[j*256+i]=colormap(i,j);
    for(j=128; j<256; j++)
      cmap[j*256+i]=colormap2(i,256-j);
  }
  f=fopen("cmap", "wb");
  fwrite(cmap, 256, 256, f);
  fclose(f);
}

void initspotlight()
{ int j, k, n=0, q;
  for(j=0; j<328; j++)
    for(k=0; k<448; k++, n++)
    { q=spotint-((j-164)*(j-164)+(k-224)*(k-224)*2/3)/220+rand()%8;
      if(q<0) spotlight[n]=0;
      else spotlight[n]=q;
    }
}

void advbg()
{ spotx+=spotxv;
  spoty+=spotyv;
  if(spotx<64*16) spotxv++; else spotxv--;
  if(spoty<32*16) spotyv++; else spotyv--;
}

void drawbg()
{ int i, j, n=0;
  char *s, *d;

  if(spotlite)
  { for(j=0; j<200; j++)
    { s=bgp+j*320;
      if(crackr) d=spawtlight+(j+spoty/16)*448+spotx/16;/*cracki+j*320;*/
      else d=spotlight+(j+spoty/16)*448+spotx/16;
      for(i=0; i<320; i++)
        screen2[n++]=cmap[*d++*256+*s++];
    }
  }
  else memcpy(screen2, bgp, 64000);
}

void initjoy()
{ int i, j, n=0;
  for(i=0; i<45; i++)
    for(j=0; j<37; j++)
      joydat[n++]=((int)pal[joyp[i*320+j]*3]+
                   (int)pal[joyp[i*320+j]*3+1]+
                   (int)pal[joyp[i*320+j]*3+2])*127/189;
  for(n=i=0; i<47; i++)
    for(j=0; j<43; j++)
      yojdat[n++]=((int)pal[yojp[i*320+j]*3]+
                   (int)pal[yojp[i*320+j]*3+1]+
                   (int)pal[yojp[i*320+j]*3+2])*127/189;


}

void initpalint()
{ int i;

  for(i=0; i<256; i++)
  { palint[i]=((int)pal[i*3]+(int)pal[i*3+1]+
               (int)pal[i*3+2])*127/189+128;
    palint2[i]=((int)pal2[i*3]+(int)pal2[i*3+1]+
                (int)pal2[i*3+2])*127/189+128;
  }
}

void initcrack()
{ int i, j, q;

  for(i=1; i<64000; i++)
  { if(!(i%320)) crackp[i++]=128;
    q=(palint2[crackp[i-1]]-palint2[crackp[i]]);
    q*=q;
//q+=128;
    if(q>=255) q=255;
    cracki[i]=q;
  }
  for(i=320; i<63780; i++)
    cracki[i]=(cracki[i-320]+cracki[i-1]+cracki[i+1]+cracki[i+320])/4;
  for(i=0; i<320; i++) cracki[i]=cracki[63999-i]=0;
  for(i=0; i<328; i++)
    for(j=0; j<448; j++)
      if(i>32 && i<232 && j>64 && j<384)
      { q=255;
        if(i<64) q-=(64-i)*8;
        if(i>200) q-=(i-200)*8;
        if(j<96) q-=(96-j)*8;
        if(j>352) q-=(j-352)*8;
        if(q<0) q=0;
/*        if((*/spawtlight[i*448+j]=
           spotlight[i*448+j]-q*cracki[(i-32)*320+j-64]/350;/*>196)
          spawtlight[i*448+j]=0;*/
      }
      else
        spawtlight[i*448+j]=spotlight[i*448+j];
}

void bannerandstuff()
{ printf("\nWell, it hasn't crashed yet.  This is a good sign."
         "\nW, E, R, and T all toggle various features just in case the"
         "\nframerate needs help.  + and - change the actual speed of the"
         "\ndemo.  Q toggles the waitretrace, which is not recommended for"
         "\nvarious reasons."
         "\n\nPress esc to quit, enter to configure sound if you don't trust"
         "\nMidas, or any other key to continue.");
  fflush(stdout);
}

void bamto(char *scrn)
{ int i,j;
  char pal3[768];

  outp(0x3c8,0);
  for(i=0; i<768; i++)
    outp(0x3c9,63);

  memcpy(screen,scrn,64000);
  for(i=0; i<64; i++)
  { for(j=0; j<768; j++)
      pal3[j]=(pal2[j]*i+63*(63-i))/64;
    setpal(pal3);
    delay(25);
    if(kbhit()) i=63;
  }
}

int sine[2048];

void initsine()
{
  int i;

  for(i=0; i<2048; i++)
    sine[i]=sin(i*3.1415926/1024)*32768;
}

void fadeout(char *scrn)
{ static char pal3[768];
  int i, j, n;

  for(i=63; i>=0; i--)
  { for(j=1; j<199; j++)
    { n=sine[(i*3+j)*64%2048]/1024*(64-i)/64;
      if(n<0) memcpy(screen+j*320,scrn+j*320-n,320+n);
      else memcpy(screen+j*320+n,scrn+j*320,320-n);
    }
    for(j=0; j<768; j++)
      pal3[j]=pal2[j]*i/64;
    setpal(pal3);
    delay(25);
    if(kbhit()) i=0;
  }
}

main()
{ int c, f=0, n=0, tt=0, tf=0, speed=10;
  char k=0;
//return 0;
  setbuf(stdout,0);
  initpudfile("sb99inv.pud");
  printf("Loading and calculating various things..."); fflush(stdout);
  logo=loadlump("image.logo");
  font=loadlump("font.scroller");
  joy=loadlump("image.joy");
  yoj=loadlump("image.yoj");
  pal=loadlump("palette");
  pal2=loadlump("palette.crackbot");
  bg=loadlump("image.bg");
  scroll=loadlump("text.scroll");
  cmap=loadlump("colormap");
//  initcmap();
  crack=loadlump("image.crackbot");
  initspotlight();
  makewordlist(scroll);
  initpalint();
  loadpcx(logo, logop);
  loadpcx(bg, bgp);
  loadpcx(joy, joyp);
  loadpcx(yoj, yojp);
  loadpcx(crack, crackp);
  initjoy();
  initscroller();
  initfeedback();
  initsine();
  initcrack();
  srand((unsigned)time(NULL));
  printf("done\n");
  bannerandstuff();
  k=getch();
  if(k==27) return 0;
  startmusic(k==13);  
  c=clock();
  tt=clock();
  initvga();
  setpal(pal);
  while(k!=27)
  { while(frame-->0)
    { if(++n>4)
      { advbg();
        advlogo();
        advjoy();
        advjoy();
        n=0;
      }
      advscroller();
    }
    drawbg();
    drawjoy();
    drawscroller();
    drawlogo();
    if(waitr) waitretrace();
    memcpy(screen, screen2, 64000);
    tf++;
    if(kbhit())
    { k=getch();
      if(k=='q') waitr=!waitr;
      if(k=='w') antialias=!antialias;
      if(k=='e') spotlite=!spotlite;
      if(k=='r') shadow=!shadow;
      if(k=='t') dlogo=!dlogo;
      if(k=='y') scroll[scrp]=0;
      if(k=='u') crackr=!crackr;
      if(k=='i') joyscrowl=!joyscrowl;
      if(k=='+') speed++;
      if(k=='-') speed--;
      if(speed<1) speed=1;
      if(k=='[')
      { spotint-=10;
        initspotlight();
      }
      if(k==']')
      { spotint+=10;
        initspotlight();
      }
    }
  }
  while(kbhit()) getch();
  bamto(crackp);
  getch();
  fadeout(crackp);
  textmode();
  stopmusic();
  printf("sb99 invtro.  a lightspeed production.\n"
         "see you there!");
  return 0;
}
